#-----------------------------------------------------------------------
# Apache configuration for AE-DIR provider (web2ldap etc.)
# - overrides configuration of your Linux distribution
# - hard-coded configuration (loading modules etc.)
#
# {{ ansible_managed }}
#-----------------------------------------------------------------------

# load required Apache modules
{% for mod in apache2_config.modules %}
LoadModule {{ mod }}_module {{ apache2_config.mod_dir }}/mod_{{ mod }}.so
{% endfor %}
{% if apache_status_urlpath %}
LoadModule status_module {{ apache2_config.mod_dir }}/mod_status.so
{% endif %}

ServerTokens ProductOnly
ServerAdmin {{ apache_server_admin }}
ServerSignature EMail
ServerName {{ apache_service_fqdn }}

# MIME-Types initialisieren
TypesConfig /etc/mime.types

# where to send error log messages (e.g. web2ldap traceback of unhandled exceptions)
ErrorLog {{ apache_error_log }}
# At least 'notice' is required to get error messages written by
# applications to stderr (e.g. web2ldap)
LogLevel {{ apache_log_level }}

# disable ETag response header
FileETag None

# disable TRACE requests
TraceEnable off

{% if apache_pid_file!="" %}
PidFile {{ apache_pid_file }}
{% endif %}

Timeout 300

# Parameter fuer keep-alive
KeepAlive On
MaxKeepAliveRequests 100
KeepAliveTimeout 15

StartServers 5
<IfModule prefork.c>
MinSpareServers 2
MaxSpareServers 10
</IfModule>

MaxRequestWorkers 50
MaxConnectionsPerChild 10000

User {{ apache_user }}
Group {{ apache_group }}
Suexec Off

HostnameLookups Off

LogFormat "{{ apache_log_format }}" apache_log_format

AllowEncodedSlashes Off
AddDefaultCharset Off

# for non-SSL vhost
Listen 80
# for SSL vhost
Listen 443

# SSL Session Resumption
SSLSessionCache        shmcb:{{ apache2_config.run_dir }}/ssl_scache(512000)
SSLSessionCacheTimeout  7200
SSLRandomSeed          startup file:/dev/urandom  512
SSLRandomSeed          connect builtin

# Default headers always sent
Header always set Strict-Transport-Security "max-age=15768000 ; includeSubDomains"
Header always set X-XSS-Protection "1; mode=block"
Header always set X-Content-Type-Options "nosniff"
Header always set X-Frame-Options "deny"
Header always set Frame-Options "DENY"
Header always set Content-Security-Policy "base-uri 'none'; child-src 'none'; connect-src 'none'; default-src 'none'; font-src 'self'; form-action 'self'; frame-ancestors 'none'; frame-src 'none'; img-src 'self' data:; media-src 'none'; object-src 'none'; script-src 'none'; style-src 'self';"
Header always set Referrer-Policy "same-origin"
Header always set Feature-Policy "ambient-light-sensor 'none'; autoplay 'none'; accelerometer 'none'; camera 'none'; display-capture 'none'; document-domain 'none'; encrypted-media 'none'; fullscreen 'none'; geolocation 'none'; gyroscope 'none'; magnetometer 'none'; microphone 'none'; midi 'none'; payment 'none'; picture-in-picture 'none'; speaker 'none'; sync-xhr 'none'; usb 'none'; wake-lock 'none'; vr 'none'; xr 'none'"

ProxyRequests Off
ProxyPreserveHost On

{% if apache_status_urlpath %}
# Strictly local virtual host for exposing metrics via mod_status
<VirtualHost 127.0.0.1:80 [::1]:80>

  ServerName http://localhost
  SSLEngine off

  # turn off access log for requests coming from loopback interface
  CustomLog /dev/null "-" "expr=-R '127.0.0.1/32'"

  <Location {{ apache_status_urlpath }}>
    SetHandler server-status
    Require ip 127.0.0.1
    Require ip ::1
  </Location>

</VirtualHost>
{% endif %}

<VirtualHost _default_:80>

  ServerName http://{{ apache_service_fqdn }}
{%if aedir_provider_lb_hostname and aedir_provider_lb_hostname != apache_service_fqdn and aedir_provider_lb_hostname not in aedir_hosts.provider %}
  ServerAlias {{ aedir_provider_lb_hostname }}
{%endif %}

  RedirectPermanent / https://{{ apache_service_fqdn }}/

</VirtualHost>

<VirtualHost _default_:443>

  ServerName https://{{ apache_service_fqdn }}
{%if aedir_provider_lb_hostname and aedir_provider_lb_hostname != apache_service_fqdn and aedir_provider_lb_hostname not in aedir_hosts.provider %}
  ServerAlias {{ aedir_provider_lb_hostname }}
{%endif %}

  DirectoryIndex index.html index.xhtml index.htm

  CustomLog {{ apache_access_log }} apache_log_format

  SSLEngine on

  SSLCACertificateFile {{ apache_cacert_pathname }}
  SSLCertificateFile {{ apache_cert_pathname }}
  SSLCertificateKeyFile {{ apache_key_pathname }}

  # Optionally ask for client cert
#  SSLCARevocationFile /etc/ssl/certs/crl-bundle.pem
#  SSLVerifyClient optional
#  SSLVerifyDepth 2

  SSLProtocol {{ apache_ssl_protocol }}
  SSLCipherSuite {{ apache_ssl_cipher_suite }}

  # do not use .htaccess files
  AccessFileName .htaccess-this-does-not-exist

  #---------------------------------------------------------------------
  # htdocs/
  #---------------------------------------------------------------------

  DocumentRoot "{{ aedir_htdocsdir }}"
  <Directory {{ aedir_htdocsdir }}>
    # do not use .htaccess files
    AllowOverride None

    Options -Indexes
    DirectoryIndex ae-dir.html
    AddType text/html .html
    AddType text/plain .txt .log .py .schema
    AddOutputFilterByType DEFLATE text/html text/plain text/xml text/css text/javascript application/javascript image/svg+xml

    <Limit GET POST>
{% for require in apache_htdocs_requires %}
      Require {{ require }}
{% endfor %}
    </Limit>
  </Directory>

  Header always set Strict-Transport-Security "max-age=15552000; includeSubDomains; preload"

  #---------------------------------------------------------------------
  # web2ldap (via mod_proxy_uwsgi)
  #---------------------------------------------------------------------

  <Location /web2ldap>
    ProxyPass unix:{{ aedir_rundir }}/uwsgi/web2ldap/web2ldap.sock|uwsgi://web2ldap/
    # Tell mod_ssl to set the SSL standard env vars
    SSLOptions +StdEnvVars
    <Limit GET POST>
{% for require in apache_web2ldap_requires %}
      Require {{ require }}
{% endfor %}
    </Limit>
  </Location>

  # CSS files for web2ldap
  Alias /css/web2ldap {{ web2ldapcnf_prefix }}/css
  <Location /css/web2ldap>
    <Limit GET>
{% for require in apache_web2ldap_requires %}
      Require {{ require }}
{% endfor %}
    </Limit>
  </Location>

  #----------------------------------------------------------------------
  # Æ-DIR password self-service web application (via mod_proxy_uwsgi)
  #----------------------------------------------------------------------

  RedirectPermanent /pwd /pwd/
  <Location /pwd/>
    ProxyPass unix:{{ aedir_rundir }}/uwsgi/ae-dir-pwd/ae-dir-pwd.sock|uwsgi://ae-dir-pwd/pwd/
    <Limit GET POST>
{% for require in apache_pwd_requires %}
      Require {{ require }}
{% endfor %}
    </Limit>
  </Location>

{% if oath_ldap_enabled==True %}
  #----------------------------------------------------------------------
  # OATH-LDAP enrollment web application (via mod_proxy_uwsgi)
  #----------------------------------------------------------------------

  RedirectPermanent /oath /oath/
  <Location /oath/>
    ProxyPass unix:{{ aedir_rundir }}/uwsgi/oathenroll/oathenroll.sock|uwsgi://oath_enroll/oath/
    <Limit GET POST>
{% for require in apache_oath_requires %}
      Require {{ require }}
{% endfor %}
    </Limit>
  </Location>
{% endif %}

</VirtualHost>
